;;;
;;; archive
;;;
;;; one line to give the Gauche-archive and an idea of what it does.
;;; Copyright (C) 2018 aaauuue 
;;;
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(define-module archive
  (export test-archive ;; dummy

          ;;; class
          <archive-base>
          
          ;;; function
          %open-read-archive-from-filename
          %open-read-archive-from-memory
          %close-read-archive
          %free-read-archive
          %is-read-archive-open
          %get-entry
          %read-data
          %extract-file-to-disk
          %extract-file-to-memory
          %extract-all-file
          %create-archive
          %copy-write-archive
          %write-archive-to-disk
          %write-archive-to-memory

          ;;; constant 
          ARCHIVE-FILTER-NONE     
          ARCHIVE-FILTER-GZIP     
          ARCHIVE-FILTER-BZIP2    
          ARCHIVE-FILTER-COMPRESS 
          ARCHIVE-FILTER-PROGRAM  
          ARCHIVE-FILTER-LZMA     
          ARCHIVE-FILTER-XZ       
          ARCHIVE-FILTER-UU       
          ARCHIVE-FILTER-RPM      
          ARCHIVE-FILTER-LZIP     
          ARCHIVE-FILTER-LRZIP   
          ARCHIVE-FILTER-LZOP    
          ARCHIVE-FILTER-GRZIP   
          ARCHIVE-FILTER-LZ4     

          ARCHIVE-FORMAT-BASE-MASK        
          ARCHIVE-FORMAT-CPIO                
          ARCHIVE-FORMAT-CPIO-POSIX          
          ARCHIVE-FORMAT-CPIO-BIN-LE         
          ARCHIVE-FORMAT-CPIO-BIN-BE         
          ARCHIVE-FORMAT-CPIO-SVR4-NOCRC     
          ARCHIVE-FORMAT-CPIO-SVR4-CRC       
          ARCHIVE-FORMAT-CPIO-AFIO-LARGE     
          ARCHIVE-FORMAT-SHAR               
          ARCHIVE-FORMAT-SHAR-BASE          
          ARCHIVE-FORMAT-SHAR-DUMP          
          ARCHIVE-FORMAT-TAR                
          ARCHIVE-FORMAT-TAR-USTAR          
          ARCHIVE-FORMAT-TAR-PAX-INTERCHANGE
          ARCHIVE-FORMAT-TAR-PAX-RESTRICTED 
          ARCHIVE-FORMAT-TAR-GNUTAR         
          ARCHIVE-FORMAT-ISO9660            
          ARCHIVE-FORMAT-ISO9660-ROCKRIDGE  
          ARCHIVE-FORMAT-ZIP                
          ARCHIVE-FORMAT-EMPTY              
          ARCHIVE-FORMAT-AR                 
          ARCHIVE-FORMAT-AR-GNU             
          ARCHIVE-FORMAT-AR-BSD             
          ARCHIVE-FORMAT-MTREE              
          ARCHIVE-FORMAT-RAW                
          ARCHIVE-FORMAT-XAR                
          ARCHIVE-FORMAT-LHA                
          ARCHIVE-FORMAT-CAB                
          ARCHIVE-FORMAT-RAR                
          ARCHIVE-FORMAT-7ZIP               
          ARCHIVE-FORMAT-WARC               

          ))
(select-module archive)

;; Loads extension
(dynamic-load "archive")

;;
;; Put your Scheme definitions here
;;



