#ifndef __ARCHIVE_CLASS_H__
#define __ARCHIVE_CLASS_H__

/* 
 * one line to give the Gauche-archive and an idea of what it does.
 * Copyright (C) 2018 aaauuue 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include "config.h"

#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include <archive.h>
#include <archive_entry.h>

#define GAUCHE_ARCHIVE_NONE  0
#define GAUCHE_ARCHIVE_READ  1
#define GAUCHE_ARCHIVE_WRITE 2

#define ARCHIVE_SRC_NONE   0
#define ARCHIVE_SRC_FILE   1
#define ARCHIVE_SRC_MEMORY 2

typedef struct Scm_libarchive_archive_baseRec {
     SCM_HEADER;
     int rw_type;
     int src_type;
     char *name;
     char *buf;
     size_t buflen;
     struct archive *obj;
} Scm_libarchive_archive_base;

SCM_CLASS_DECL( Scm_libarchive_archive_baseClass );
#define SCM_CLASS_LIBARCHIVE_ARCHIVE_BASE ( &Scm_libarchive_archive_baseClass )
#define SCM_LIBARCHIVE_ARCHIVE_BASE( obj ) ( ( Scm_libarchive_archive_base * )obj )
#define SCM_LIBARCHIVE_ARCHIVE_BASE_P( obj )                                        \
     SCM_XTYPEP( obj, &Scm_libarchive_archive_baseClass )

static ScmObj libarchive_archive_base_allocate( ScmClass *klass, ScmObj initargs );
void   libarchive_archive_base_finalize( ScmObj obj, void *data );

#endif /* __ARCHIVE_CLASS_H__ */
